﻿Module Summaries
    Public Sub ShowSummariesInGroups(ByRef grid As Infragistics.Web.UI.GridControls.ContainerGrid, ByRef e As Infragistics.Web.UI.GridControls.GroupedRowEventArgs)
        Dim row As Infragistics.Web.UI.GridControls.ContainerGridRecord
        Dim sumColInfo As Infragistics.Web.UI.GridControls.ColumnSummaryInfo
        Dim total As Infragistics.Web.UI.GridControls.Summary
        Dim colTotal As Infragistics.Web.UI.GridControls.GridField

        Dim valTotal As Double = 0
        Dim valRecord As Double = 0
        Dim strTotal As String = ""
        Dim strTotalCol As String = ""
        Dim sumRecords As Double = 0
        Dim nRecords As Long = 0
        Dim minRecord As Double = 0
        Dim maxRecord As Double = 0

        'iterate through columns with summaries defined
        For Each sumColInfo In grid.Behaviors.SummaryRow.ColumnSummaries
            colTotal = grid.Columns(sumColInfo.ColumnKey)
            strTotalCol = ""

            'loop through records inside the group and determine the bases to calculate totals
            sumRecords = 0
            nRecords = 0
            e.GroupedRow.Rows.Reset()
            Do While e.GroupedRow.Rows.MoveNext
                row = e.GroupedRow.Rows.Current
                valRecord = row.Items(colTotal.Index).Value
                sumRecords = sumRecords + valRecord
                If nRecords = 0 Then
                    minRecord = valRecord
                    maxRecord = valRecord
                Else
                    If valRecord < minRecord Then minRecord = valRecord
                    If valRecord > maxRecord Then maxRecord = valRecord
                End If
                nRecords = nRecords + 1
            Loop

            'iterate through the summaries associated with the column
            For Each total In sumColInfo.Summaries
                Select Case total.SummaryType
                    Case Infragistics.Web.UI.GridControls.SummaryType.Average
                        If nRecords = 0 Then
                            valTotal = 0
                        Else
                            valTotal = sumRecords / nRecords
                        End If
                    Case Infragistics.Web.UI.GridControls.SummaryType.Count
                        valTotal = nRecords
                    Case Infragistics.Web.UI.GridControls.SummaryType.Max
                        valTotal = maxRecord
                    Case Infragistics.Web.UI.GridControls.SummaryType.Min
                        valTotal = minRecord
                    Case Infragistics.Web.UI.GridControls.SummaryType.Sum
                        valTotal = sumRecords
                End Select
                strTotalCol = strTotalCol & " " & total.CustomSummaryName & "=" & valTotal
            Next

            'concatenate the name of the column totalized with summaries associated
            strTotal = strTotal & " [" & colTotal.Header.Text & ": " & Trim(strTotalCol) & "]"
        Next

        'concatenate the group text with the string summaries result
        e.GroupedRow.Text = e.GroupedRow.Text & " " & Trim(strTotal)
    End Sub
End Module
